Index: uspace/lib/c/arch/sparc64/include/libarch/config.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/config.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/config.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_CONFIG_H_
-#define LIBC_sparc64_CONFIG_H_
+#ifndef _LIBC_sparc64_CONFIG_H_
+#define _LIBC_sparc64_CONFIG_H_
 
 #if defined (SUN4U)
Index: uspace/lib/c/arch/sparc64/include/libarch/ddi.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/ddi.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/ddi.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -31,6 +31,6 @@
  */
 
-#ifndef LIBC_sparc64_DDI_H_
-#define LIBC_sparc64_DDI_H_
+#ifndef _LIBC_sparc64_DDI_H_
+#define _LIBC_sparc64_DDI_H_
 
 #include <barrier.h>
Index: uspace/lib/c/arch/sparc64/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/elf_linux.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/elf_linux.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_ELF_LINUX_H_
-#define LIBC_sparc64_ELF_LINUX_H_
+#ifndef _LIBC_sparc64_ELF_LINUX_H_
+#define _LIBC_sparc64_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/sparc64/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/faddr.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/faddr.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_FADDR_H_
-#define LIBC_sparc64_FADDR_H_
+#ifndef _LIBC_sparc64_FADDR_H_
+#define _LIBC_sparc64_FADDR_H_
 
 #include <types/common.h>
Index: uspace/lib/c/arch/sparc64/include/libarch/fibril.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/fibril.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/fibril.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_FIBRIL_H_
-#define LIBC_sparc64_FIBRIL_H_
+#ifndef _LIBC_sparc64_FIBRIL_H_
+#define _LIBC_sparc64_FIBRIL_H_
 
 #include <libarch/stack.h>
Index: uspace/lib/c/arch/sparc64/include/libarch/fibril_context.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/fibril_context.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/fibril_context.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -27,6 +27,6 @@
  */
 
-#ifndef LIBC_ARCH_FIBRIL_CONTEXT_H_
-#define LIBC_ARCH_FIBRIL_CONTEXT_H_
+#ifndef _LIBC_ARCH_FIBRIL_CONTEXT_H_
+#define _LIBC_ARCH_FIBRIL_CONTEXT_H_
 
 #define __CONTEXT_OFFSET_SP  0x00
Index: uspace/lib/c/arch/sparc64/include/libarch/rtld/dynamic.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/rtld/dynamic.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/rtld/dynamic.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_RTLD_DYNAMIC_H_
-#define LIBC_sparc64_RTLD_DYNAMIC_H_
+#ifndef _LIBC_sparc64_RTLD_DYNAMIC_H_
+#define _LIBC_sparc64_RTLD_DYNAMIC_H_
 
 typedef struct {
Index: uspace/lib/c/arch/sparc64/include/libarch/rtld/elf_dyn.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/rtld/elf_dyn.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/rtld/elf_dyn.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_RTLD_ELF_DYN_H_
-#define LIBC_sparc64_RTLD_ELF_DYN_H_
+#ifndef _LIBC_sparc64_RTLD_ELF_DYN_H_
+#define _LIBC_sparc64_RTLD_ELF_DYN_H_
 
 #define R_SPARC_COPY		19
Index: uspace/lib/c/arch/sparc64/include/libarch/rtld/module.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/rtld/module.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/rtld/module.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_RTLD_MODULE_H_
-#define LIBC_sparc64_RTLD_MODULE_H_
+#ifndef _LIBC_sparc64_RTLD_MODULE_H_
+#define _LIBC_sparc64_RTLD_MODULE_H_
 
 #include <elf/elf_mod.h>
Index: uspace/lib/c/arch/sparc64/include/libarch/stack.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/stack.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/stack.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_STACK_H_
-#define LIBC_sparc64_STACK_H_
+#ifndef _LIBC_sparc64_STACK_H_
+#define _LIBC_sparc64_STACK_H_
 
 #define STACK_ITEM_SIZE			8
Index: uspace/lib/c/arch/sparc64/include/libarch/stackarg.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/stackarg.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/stackarg.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_STACKARG_H_
-#define LIBC_sparc64_STACKARG_H_
+#ifndef _LIBC_sparc64_STACKARG_H_
+#define _LIBC_sparc64_STACKARG_H_
 
 #endif
Index: uspace/lib/c/arch/sparc64/include/libarch/syscall.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/syscall.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/syscall.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_sparc64_SYSCALL_H_
-#define LIBC_sparc64_SYSCALL_H_
+#ifndef _LIBC_sparc64_SYSCALL_H_
+#define _LIBC_sparc64_SYSCALL_H_
 
 #include <stdint.h>
Index: uspace/lib/c/arch/sparc64/include/libarch/thread.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/thread.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/thread.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -32,6 +32,6 @@
  */
 
-#ifndef LIBC_sparc64_THREAD_H_
-#define LIBC_sparc64_THREAD_H_
+#ifndef _LIBC_sparc64_THREAD_H_
+#define _LIBC_sparc64_THREAD_H_
 
 #endif
Index: uspace/lib/c/arch/sparc64/include/libarch/tls.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/tls.h	(revision b4f117122b26d549e7cdbd586de66b7c21511361)
+++ uspace/lib/c/arch/sparc64/include/libarch/tls.h	(revision 4805495a910f793f8918c13f029a38a5bb548154)
@@ -36,6 +36,6 @@
  */
 
-#ifndef LIBC_sparc64_TLS_H_
-#define LIBC_sparc64_TLS_H_
+#ifndef _LIBC_sparc64_TLS_H_
+#define _LIBC_sparc64_TLS_H_
 
 #define CONFIG_TLS_VARIANT_2