Index: uspace/lib/c/generic/async/client.c
===================================================================
--- uspace/lib/c/generic/async/client.c	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ uspace/lib/c/generic/async/client.c	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
@@ -111,5 +111,5 @@
 #include <errno.h>
 #include <sys/time.h>
-#include <libarch/barrier.h>
+#include <barrier.h>
 #include <stdbool.h>
 #include <stdlib.h>
Index: uspace/lib/c/generic/async/ports.c
===================================================================
--- uspace/lib/c/generic/async/ports.c	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ uspace/lib/c/generic/async/ports.c	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
@@ -42,5 +42,5 @@
 #include <errno.h>
 #include <sys/time.h>
-#include <libarch/barrier.h>
+#include <barrier.h>
 #include <stdbool.h>
 #include <stdlib.h>
Index: uspace/lib/c/generic/smp_memory_barrier.c
===================================================================
--- uspace/lib/c/generic/smp_memory_barrier.c	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ uspace/lib/c/generic/smp_memory_barrier.c	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
@@ -33,5 +33,5 @@
  */
 
-#include <smp_memory_barrier.h>
+#include <barrier.h>
 #include <libc.h>
 
Index: uspace/lib/c/generic/thread/rcu.c
===================================================================
--- uspace/lib/c/generic/thread/rcu.c	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ uspace/lib/c/generic/thread/rcu.c	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
@@ -71,10 +71,9 @@
 #include <stdio.h>
 #include <stddef.h>
-#include <compiler/barrier.h>
-#include <libarch/barrier.h>
+#include <barrier.h>
 #include <macros.h>
 #include <async.h>
 #include <adt/list.h>
-#include <smp_memory_barrier.h>
+#include <barrier.h>
 #include <assert.h>
 #include <time.h>
Index: uspace/lib/c/generic/time.c
===================================================================
--- uspace/lib/c/generic/time.c	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ uspace/lib/c/generic/time.c	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
@@ -38,5 +38,5 @@
 #include <time.h>
 #include <stdbool.h>
-#include <libarch/barrier.h>
+#include <barrier.h>
 #include <macros.h>
 #include <errno.h>
Index: uspace/lib/c/include/barrier.h
===================================================================
--- uspace/lib/c/include/barrier.h	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
+++ uspace/lib/c/include/barrier.h	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2012 Adam Hraska
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_COMPILER_BARRIER_H_
+#define LIBC_COMPILER_BARRIER_H_
+
+#include <libarch/barrier.h>
+
+extern void smp_memory_barrier(void);
+
+#define compiler_barrier() asm volatile ("" ::: "memory")
+
+/** Forces the compiler to access (ie load/store) the variable only once. */
+#define ACCESS_ONCE(var) (*((volatile typeof(var)*)&(var)))
+
+#endif /* LIBC_COMPILER_BARRIER_H_ */
Index: uspace/lib/c/include/compiler/barrier.h
===================================================================
--- uspace/lib/c/include/compiler/barrier.h	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ 	(revision )
@@ -1,43 +1,0 @@
-/*
- * Copyright (c) 2012 Adam Hraska
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup libc
- * @{
- */
-/** @file
- */
-
-#ifndef LIBC_COMPILER_BARRIER_H_
-#define LIBC_COMPILER_BARRIER_H_
-
-#define compiler_barrier() asm volatile ("" ::: "memory")
-
-/** Forces the compiler to access (ie load/store) the variable only once. */
-#define ACCESS_ONCE(var) (*((volatile typeof(var)*)&(var)))
-
-#endif /* LIBC_COMPILER_BARRIER_H_ */
Index: uspace/lib/c/include/rcu.h
===================================================================
--- uspace/lib/c/include/rcu.h	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ uspace/lib/c/include/rcu.h	(revision 05882233d8ca97c6879ac5c42456c344c8569d89)
@@ -37,6 +37,5 @@
 #define LIBURCU_RCU_H_
 
-#include <compiler/barrier.h>
-#include <libarch/barrier.h>
+#include <barrier.h>
 #include <stdbool.h>
 
Index: uspace/lib/c/include/smp_memory_barrier.h
===================================================================
--- uspace/lib/c/include/smp_memory_barrier.h	(revision 498ced18a4f90fe1c9eee028e354d61b39de484d)
+++ 	(revision )
@@ -1,43 +1,0 @@
-/*
- * Copyright (c) 2012 Adam Hraska
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup libc
- * @{
- */
-/** @file
- */
-
-#ifndef LIBC_SMP_MEM_BAR_H_
-#define LIBC_SMP_MEM_BAR_H_
-
-extern void smp_memory_barrier(void);
-
-#endif
-
-/** @}
- */